grammar O;

WS: [ \n\t\r]+ -> skip;

expr:
	'(' expr ')'			# parenth
	| '-' expr				# log_neg
	| expr op = '->' expr	# log_impl
	| expr op = '<->' expr	# log_iff
	| expr op = '|' expr	# log_or
	| expr op = '&' expr	# log_and
	| ATOM					# atom;

ATOM: [a-z][a-zA-Z0-9]*;
